// EventCodeList.cpp : implementation file
//

#include "stdafx.h"
#include "FF4Edit.h"
#include "EventCodeList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEventCodeList

CEventCodeList::CEventCodeList()
{
}

CEventCodeList::~CEventCodeList()
{
}


BEGIN_MESSAGE_MAP(CEventCodeList, CListBox)
	//{{AFX_MSG_MAP(CEventCodeList)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEventCodeList message handlers

int g_eventImages[] = {
	9, 9, 9, 12, 1, 3, 9, 0,
	8, 1, 9, 10, 1, 0, 10, 10,
	4, 4, 12, 10, 10, 4, 4, 0,
	0, 6, 8, 7, 2, 1, 12, 5,
	5, 5, 12, 12, 12, 12, 5, 1,
	1, 9, 8, 8, 12, 9, 3, 11
};

void CEventCodeList::MeasureItem(LPMEASUREITEMSTRUCT lpmis) 
{
	lpmis->itemHeight = 20;
}

void CEventCodeList::DrawItem(LPDRAWITEMSTRUCT lpdis) 
{
	CDC dc;  dc.Attach(lpdis->hDC);

	CRect rect = lpdis->rcItem;
	UINT nIndex = lpdis->itemID;

	if(nIndex != (UINT)-1)
	{
		int nImage;
		DWORD dwData = GetItemData(nIndex);
		int nCode = dwData & ~0xC0000000;

		if(nCode < 0xD0) nImage = 0;
		else nImage = g_eventImages[nCode - 0xD0];

		CString strText;  GetText(nIndex, strText);
		CRect textRect = rect;

		if(dwData & 0x80000000)
		{
			m_treeLines.Draw(&dc, 3, CPoint(textRect.left, textRect.top), ILD_NORMAL);
			m_treeLines.Draw(&dc, 1, CPoint(textRect.left + 20, textRect.top), ILD_NORMAL);
		}
		else if(dwData & 0x40000000)
		{
			m_treeLines.Draw(&dc, 3, CPoint(textRect.left, textRect.top), ILD_NORMAL);
			m_treeLines.Draw(&dc, 2, CPoint(textRect.left + 20, textRect.top), ILD_NORMAL);
		}
		else
		{
			if(nIndex == 0)
				m_treeLines.Draw(&dc, 0, CPoint(textRect.left, textRect.top), ILD_NORMAL);
			else if(nIndex == GetCount() - 1)
				m_treeLines.Draw(&dc, 2, CPoint(textRect.left, textRect.top), ILD_NORMAL);
			else
				m_treeLines.Draw(&dc, 1, CPoint(textRect.left, textRect.top), ILD_NORMAL);
		}

		textRect.left += 20;
		if(dwData & 0xC0000000) textRect.left += 20;

		if(m_images.GetSafeHandle())
		{
			m_images.Draw(&dc, nImage,
				CPoint(textRect.left, textRect.top + (textRect.Height() - 16) / 2), ILD_NORMAL);

			textRect.left += 16;
		}

		textRect.left += 4;

		dc.FillSolidRect(textRect, ::GetSysColor((lpdis->itemState & ODS_SELECTED) ?
			COLOR_HIGHLIGHT : COLOR_WINDOW));
		if(lpdis->itemState & ODS_FOCUS) dc.DrawFocusRect(&textRect);
		
		textRect.left += 4;

		CFont* oldFont = dc.SelectObject(GetFont());
		dc.SetBkMode(TRANSPARENT);
		dc.SetTextColor(::GetSysColor((lpdis->itemState & ODS_SELECTED) ?
			COLOR_HIGHLIGHTTEXT : COLOR_WINDOWTEXT));
		dc.DrawText(strText, &textRect, DT_LEFT | DT_VCENTER | DT_SINGLELINE | DT_NOPREFIX);
		dc.SelectObject(oldFont);
	}

	dc.Detach();
}

void CEventCodeList::PreSubclassWindow() 
{
	CListBox::PreSubclassWindow();

	m_images.Create(IDB_EVENTIMAGES, 16, 0, RGB(255, 0, 255));
	m_treeLines.Create(IDB_TREELINES, 20, 0, RGB(255, 0, 255));
}
