// EventsFormView.cpp : implementation file
//

#include "stdafx.h"
#include "FF4Edit.h"
#include "FF4Doc.h"
#include "EventsFormView.h"

#include "FF4EventConstants.cpp"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEventsFormView

IMPLEMENT_DYNCREATE(CEventsFormView, cdxCSizingFormView)

CEventsFormView::CEventsFormView()
	: cdxCSizingFormView(CEventsFormView::IDD)
{
	//{{AFX_DATA_INIT(CEventsFormView)
	//}}AFX_DATA_INIT
}

CEventsFormView::~CEventsFormView()
{
}

void CEventsFormView::DoDataExchange(CDataExchange* pDX)
{
	cdxCSizingFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEventsFormView)
	DDX_Control(pDX, IDC_BITFIELD1, m_wndBitField1);
	DDX_Control(pDX, IDC_STATIC_BOX, m_wndStaticBox);
	DDX_Control(pDX, IDC_LABEL0, m_wndLabel0);
	DDX_Control(pDX, IDC_LABEL4, m_wndLabel4);
	DDX_Control(pDX, IDC_LABEL3, m_wndLabel3);
	DDX_Control(pDX, IDC_LABEL2, m_wndLabel2);
	DDX_Control(pDX, IDC_LABEL1, m_wndLabel1);
	DDX_Control(pDX, IDC_EVENTDESCRIPTION, m_wndEventDescription);
	DDX_Control(pDX, IDC_COMBO1, m_wndCombo1);
	DDX_Control(pDX, IDC_EDITACTUAL1, m_wndEditActual1);
	DDX_Control(pDX, IDC_EDIT4, m_wndEdit4);
	DDX_Control(pDX, IDC_EDIT3, m_wndEdit3);
	DDX_Control(pDX, IDC_EDIT2, m_wndEdit2);
	DDX_Control(pDX, IDC_EDIT1, m_wndEdit1);
	DDX_Control(pDX, IDC_EVENTCLEAR, m_wndEventCodeClear);
	DDX_Control(pDX, IDC_STATIC_EVENT, m_wndStaticEvent);
	DDX_Control(pDX, IDC_STATIC_COMMAND, m_wndStaticCommand);
	DDX_Control(pDX, IDC_EVENTCOMMAND, m_wndEventCommand);
	DDX_Control(pDX, IDC_MINBOUNDS, m_wndMinBounds);
	DDX_Control(pDX, IDC_SEP2, m_wndSep2);
	DDX_Control(pDX, IDC_SEP1, m_wndSep1);
	DDX_Control(pDX, IDC_EVENTPLAY, m_wndEventPlay);
	DDX_Control(pDX, IDC_EVENTCODEUP, m_wndEventCodeUp);
	DDX_Control(pDX, IDC_EVENTCODEDOWN, m_wndEventCodeDown);
	DDX_Control(pDX, IDC_EVENTCODEDELETE, m_wndEventCodeDelete);
	DDX_Control(pDX, IDC_EVENTCODEADD, m_wndEventCodeAdd);
	DDX_Control(pDX, IDC_EVENTLIST, m_wndEventList);
	DDX_Control(pDX, IDC_EVENTCODE, m_wndEventCode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEventsFormView, cdxCSizingFormView)
	//{{AFX_MSG_MAP(CEventsFormView)
	ON_CBN_SELENDOK(IDC_EVENTLIST, OnChangeEventList)
	ON_WM_SIZE()
	ON_LBN_SELCHANGE(IDC_EVENTCODE, OnSelChangeEventCode)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEventsFormView diagnostics

#ifdef _DEBUG
void CEventsFormView::AssertValid() const
{
	cdxCSizingFormView::AssertValid();
}

void CEventsFormView::Dump(CDumpContext& dc) const
{
	cdxCSizingFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEventsFormView message handlers


void CEventsFormView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	m_wndEventList.ResetContent();
	m_wndEventCommand.ResetContent();
	m_nCurrentEvent = 0x00;

	CString s;
	for(int i = 0; i < 256; i++)
	{
		s.Format("Event 0x%02X", i);
		m_wndEventList.AddString(s);
	}

	for(i = 0; i < sizeof(g_charCommands) / sizeof(COMBOBOXEXITEM); i++)
	{
		g_charCommands[i].mask = CBEIF_IMAGE | CBEIF_SELECTEDIMAGE | CBEIF_INDENT | CBEIF_TEXT |
			CBEIF_LPARAM;
		m_wndEventCommand.InsertItem(&g_charCommands[i]);
	}

	m_wndEventList.SetCurSel(0);

	UpdateCode();
}

void CEventsFormView::UpdateCode()
{
	CFF4Doc* pDoc = GetDocument();

	Event* pEvent = &pDoc->events[m_nCurrentEvent];

	CString s, t;
	m_wndEventCode.ResetContent();
	m_wndEventCode.SetItemHeight(0, 20);

	BOOL bIndentNext = FALSE;
	BYTE nIndent = 0;
	BYTE bCode;
	DWORD dwData;

	m_wndEventCode.SetRedraw(FALSE);

	// Parse the bytecode and fill the list.
	for(int i = 0; i < pEvent->code.GetSize(); i++)
	{
		bCode = pEvent->code[i]->command;
		dwData = bCode;

		if(bCode >= 0x00 && bCode < 0xC0)
		{
			int nChar = bCode / 16;
			int nMove = bCode % 16;

			t.Format("character %d", nChar);
			s.Format(g_charMoves[nMove], t);
		}
		else if(bCode >= 0xC0 && bCode < 0xD0)
		{
			int nMove = bCode % 16;

			t = "main character";
			s.Format(g_charMoves[nMove], t);
		}
		else
		{
			int nRes = GetShortCommandDescription(pEvent->code[i], s);
			if(nIndent == 0) nIndent = nRes;
		}

		if(bIndentNext)
		{
			if(nIndent == 1) dwData |= 0x40000000;
			else dwData |= 0x80000000;

			nIndent--;
		}

		if(nIndent)
			bIndentNext = TRUE;
		else
			bIndentNext = FALSE;

		int nIndex = m_wndEventCode.AddString(s);
		m_wndEventCode.SetItemData(nIndex, dwData);
	}

	m_wndEventCode.SetCurSel(0);
	m_wndEventCode.SetRedraw(TRUE);
	Invalidate();
	UpdateControls();
}

void CEventsFormView::UpdateControls()
{
	CFF4Doc* pDoc = GetDocument();

	int nCommand = m_wndEventCode.GetCurSel();
	Event* pEvent = &pDoc->events[m_nCurrentEvent];
	BYTE bCommand = pEvent->code[nCommand]->command;

	m_currentCmd = pDoc->events[m_nCurrentEvent].code[nCommand];

	m_wndEventCodeUp.EnableWindow(TRUE);
	m_wndEventCodeDown.EnableWindow(TRUE);
	m_wndEventCodeDelete.EnableWindow(TRUE);

	if(nCommand == 0)
	{
		m_wndEventCodeUp.EnableWindow(FALSE);
	}
	if(nCommand == m_wndEventCode.GetCount() - 2)
	{
		m_wndEventCodeDown.EnableWindow(FALSE);
	}
	if(bCommand == 0xFF)
	{
		m_wndEventCodeUp.EnableWindow(FALSE);
		m_wndEventCodeDown.EnableWindow(FALSE);
		m_wndEventCodeDelete.EnableWindow(FALSE);
	}

	int nCommandIndex = FindCommand(bCommand);
	m_wndEventCommand.SetCurSel(nCommandIndex);

	if(bCommand >= 0xD0)
	{
		SetRichEditText(g_eventDescD0[bCommand - 0xD0]);
	}

	UpdateParameterControls();
}

int CEventsFormView::GetShortCommandDescription(EventCommand* pCommand, CString& desc)
{
	CFF4Doc* pDoc = GetDocument();

	CString s, t;
	int n;

	switch(pCommand->command)
	{
		case 0xD0:
		case 0xD1:
		case 0xD2:
		case 0xD3:
		case 0xD4:
		case 0xD5:
		case 0xD6:
		case 0xD7:
		case 0xD8:
		case 0xD9:
		case 0xDA:
			desc = g_eventCodesD0[pCommand->command - 0xD0];
			break;

		case 0xDB:
		case 0xE3:
		case 0xE4:
			if(pCommand->params[0] & 0x01) s += "Poison";
			if(pCommand->params[0] & 0x02) { if(!s.IsEmpty()) { s += ", "; } s += "Darkness"; }
			if(pCommand->params[0] & 0x04) { if(!s.IsEmpty()) { s += ", "; } s += "Mute"; }
			if(pCommand->params[0] & 0x08) { if(!s.IsEmpty()) { s += ", "; } s += "Piggy"; }
			if(pCommand->params[0] & 0x10) { if(!s.IsEmpty()) { s += ", "; } s += "Small"; }
			if(pCommand->params[0] & 0x20) { if(!s.IsEmpty()) { s += ", "; } s += "Toad"; }
			if(pCommand->params[0] & 0x40) { if(!s.IsEmpty()) { s += ", "; } s += "Stone"; }
			if(pCommand->params[0] & 0x80) { if(!s.IsEmpty()) { s += ", "; } s += "Swoon"; }

			if(pCommand->command == 0xE3) { if(s.IsEmpty()) { desc = "Remove all status ailments"; break; } }

			if(s.IsEmpty()) s = "none";

			desc.Format(g_eventCodesD0[pCommand->command - 0xD0], s);
			break;

		case 0xDC:
			desc.Format(g_eventCodesD0[0x0C], 50 * (1 << pCommand->params[0]));
			break;

		case 0xDD:
			desc.Format(g_eventCodesD0[0x0D], pCommand->params[0]);
			break;

		case 0xDE:
		case 0xDF:
			desc.Format(g_eventCodesD0[pCommand->command - 0xD0], pCommand->params[0] * 10);
			break;

		case 0xE0:
		case 0xE1:
		case 0xF7:
			desc.Format(g_eventCodesD0[pCommand->command - 0xD0],
				FixedTextToCString(pDoc->items[pCommand->params[0]].name, 9,
				TTCS_TrimTrailingSpaces, TRUE,
				TAG_END, 0));
			break;

		case 0xE2:
			desc.Format(g_eventCodesD0[0x12], pCommand->params[0], pCommand->params[1]);
			break;

		case 0xE5:
			desc.Format(g_eventCodesD0[0x15], pCommand->params[0] * 100);
			break;

		case 0xE6:
			desc.Format(g_eventCodesD0[0x16], pCommand->params[0] * 50);
			break;

		case 0xE7:
		case 0xE8:
			desc.Format(g_eventCodesD0[pCommand->command - 0xD0], pCommand->params[0]);
			break;

		case 0xE9:
			desc.Format(g_eventCodesD0[0x19], pCommand->params[0]);
			break;

		case 0xEA:
			if(pCommand->params[0] == 0x00)
				desc = "Stop music";
			else
				desc.Format(g_eventCodesD0[0x1A], g_songTitles[pCommand->params[0] - 1]);
			break;

		case 0xEB:
			if(pCommand->params[1] == 1) s = "action"; else s = "actions";
			if(pCommand->params[0] == 1) t = "time"; else t = "times";
			desc.Format(g_eventCodesD0[0x1B], pCommand->params[1], s, pCommand->params[0], t);
			return pCommand->params[1];
			break;

		case 0xEC:
			desc.Format(g_eventCodesD0[0x1C], pCommand->params[0]);
			break;

		case 0xED:
			desc.Format(g_eventCodesD0[0x1D], pCommand->params[0]);
			break;

		case 0xEE:
			desc.Format(g_eventCodesD0[0x1E], pCommand->params[0]);
			break;

		case 0xEF:
		case 0xF0:
		case 0xF1:
		case 0xF6:
		case 0xF8:
			desc.Format(g_eventCodesD0[pCommand->command - 0xD0], pCommand->params[0]);
			break;

		case 0xF2:
		case 0xF3:
		case 0xF4:
		case 0xF5:
			desc.Format(g_eventCodesD0[pCommand->command - 0xD0], pCommand->params[0]);
			break;

		case 0xF9:
			desc.Format(g_eventCodesD0[0x29], pCommand->params[0]);
			break;

		case 0xFA:
			if(pCommand->params[0] == 0x00)
				desc = "Stop music";
			else
				desc.Format(g_eventCodesD0[0x2A], g_songTitles[pCommand->params[0] - 1]);
			break;

		case 0xFB:
			desc.Format(g_eventCodesD0[0x2B], pCommand->params[0]);
			break;

		case 0xFC:
			desc = "Command 0xFC:  As far as I know, this is not used.";
			break;

		case 0xFD:
			desc.Format(g_eventCodesD0[0x2D], pCommand->params[0]);
			break;

		case 0xFE:
			if(pCommand->params[3] & 0x80) n = 1;
			else n = 0;

			if(pCommand->params[0] == 251) s = "Overworld map";
			else if(pCommand->params[0] == 252) s = "Underground map";
			else if(pCommand->params[0] == 253) s = "Moon map";
			else s.Format("map %d from bank %d", pCommand->params[0], n);
			
			desc.Format(g_eventCodesD0[0x2E], s, pCommand->params[1], pCommand->params[2]);
			break;

		case 0xFF:
			desc = g_eventCodesD0[0x2F];
			break;
	}

	return 0;
}

void CEventsFormView::UpdateParameterControls()
{
	char paramVal[16], actualVal[16];
	CString s;
	int i = 0;

	CFF4Doc* pDoc = GetDocument();

	m_wndLabel0.ShowWindow(SW_HIDE);
	m_wndLabel1.ShowWindow(SW_HIDE);
	m_wndLabel2.ShowWindow(SW_HIDE);
	m_wndLabel3.ShowWindow(SW_HIDE);
	m_wndLabel4.ShowWindow(SW_HIDE);
	m_wndBitField1.ShowWindow(SW_HIDE);
	m_wndCombo1.ShowWindow(SW_HIDE);
	m_wndEdit1.ShowWindow(SW_HIDE);
	m_wndEditActual1.ShowWindow(SW_HIDE);
	m_wndEdit2.ShowWindow(SW_HIDE);
	m_wndEdit3.ShowWindow(SW_HIDE);
	m_wndEdit4.ShowWindow(SW_HIDE);

	m_wndCombo1.ResetContent();
	m_wndCombo1.SetItemHeight(0, 16);
	
	switch(m_currentCmd->command)
	{
		case 0xDB:
		case 0xE3:
		case 0xE4:
			if(m_currentCmd->command == 0xDB)
				m_wndLabel1.SetWindowText("Status ailments to toggle:");
			else if(m_currentCmd->command == 0xE3)
				m_wndLabel1.SetWindowText("Status ailments that will not be removed:");
			else if(m_currentCmd->command == 0xE4)
				m_wndLabel1.SetWindowText("Status ailments to set:");
			
			m_wndBitField1.SetValue(m_currentCmd->params[0]);
			m_wndBitField1.SetBitName(0, _T("Poison"));
			m_wndBitField1.SetBitName(1, _T("Darkness"));
			m_wndBitField1.SetBitName(2, _T("Mute"));
			m_wndBitField1.SetBitName(3, _T("Piggy"));
			m_wndBitField1.SetBitName(4, _T("Small"));
			m_wndBitField1.SetBitName(5, _T("Toad"));
			m_wndBitField1.SetBitName(6, _T("Stone"));
			m_wndBitField1.SetBitName(7, _T("Swoon"));

			m_wndLabel1.ShowWindow(SW_SHOW);
			m_wndBitField1.ShowWindow(SW_SHOW);
			break;

		case 0xDC:
			itoa(m_currentCmd->params[0], paramVal, 10);
			itoa(50 * 1 << m_currentCmd->params[0], actualVal, 10);

			m_wndLabel1.SetWindowText("Amount of gold to pay:");
			m_wndEdit1.SetWindowText(paramVal);
			m_wndEditActual1.SetWindowText(actualVal);

			m_wndLabel1.ShowWindow(SW_SHOW);
			m_wndEdit1.ShowWindow(SW_SHOW);
			m_wndEditActual1.ShowWindow(SW_SHOW);
			break;

		case 0xDE:
		case 0xDF:
			itoa(m_currentCmd->params[0], paramVal, 10);
			itoa(10 * m_currentCmd->params[0], actualVal, 10);

			if(m_currentCmd->command == 0xDE)
				m_wndLabel1.SetWindowText("Amount of HP to restore:");
			else if(m_currentCmd->command == 0xDF)
				m_wndLabel1.SetWindowText("Amount of MP to restore:");

			m_wndEdit1.SetWindowText(paramVal);
			m_wndEditActual1.SetWindowText(actualVal);

			m_wndLabel1.ShowWindow(SW_SHOW);
			m_wndEdit1.ShowWindow(SW_SHOW);
			m_wndEditActual1.ShowWindow(SW_SHOW);
			break;

		case 0xE0:
		case 0xE1:
			if(m_currentCmd->command == 0xE0)
				m_wndLabel1.SetWindowText("Item to add:");
			else if(m_currentCmd->command == 0xE1)
				m_wndLabel1.SetWindowText("Item to remove:");

			for(i = 0; i < 0x100; i++)
			{
				m_wndCombo1.AddString(FixedTextToCString(pDoc->items[i].name, 9,
					TTCS_TrimTrailingSpaces, TRUE,
					TAG_END, 0));
			}

			m_wndCombo1.SetCurSel(m_currentCmd->params[0]);

			m_wndLabel1.ShowWindow(SW_SHOW);
			m_wndCombo1.ShowWindow(SW_SHOW);
			break;

		case 0xE5:
			itoa(m_currentCmd->params[0], paramVal, 10);
			itoa(100 * m_currentCmd->params[0], actualVal, 10);

			m_wndLabel1.SetWindowText("Amount of gold to give:");

			m_wndEdit1.SetWindowText(paramVal);
			m_wndEditActual1.SetWindowText(actualVal);

			m_wndLabel1.ShowWindow(SW_SHOW);
			m_wndEdit1.ShowWindow(SW_SHOW);
			m_wndEditActual1.ShowWindow(SW_SHOW);
			break;

		case 0xE6:
			itoa(m_currentCmd->params[0], paramVal, 10);
			itoa(50 * m_currentCmd->params[0], actualVal, 10);

			m_wndLabel1.SetWindowText("Amount of gold to give:");

			m_wndEdit1.SetWindowText(paramVal);
			m_wndEditActual1.SetWindowText(actualVal);

			m_wndLabel1.ShowWindow(SW_SHOW);
			m_wndEdit1.ShowWindow(SW_SHOW);
			m_wndEditActual1.ShowWindow(SW_SHOW);
			break;

		case 0xE7:
		case 0xE8:
			if(m_currentCmd->command == 0xE7)
				m_wndLabel1.SetWindowText("Character to add:");
			else if(m_currentCmd->command == 0xE8)
				m_wndLabel1.SetWindowText("Character to remove:");

			for(i = 0; i < 0x10; i++)
			{
				m_wndCombo1.AddString(FixedTextToCString(pDoc->characters[i].name, 6,
					TTCS_TrimTrailingSpaces, TRUE,
					TAG_END, 0));
			}

			m_wndCombo1.SetCurSel(m_currentCmd->params[0]);

			m_wndLabel1.ShowWindow(SW_SHOW);
			m_wndCombo1.ShowWindow(SW_SHOW);
			break;

		case 0xEA:
		case 0xFA:
		{
			m_wndLabel1.SetWindowText("Song to play:");

			m_wndCombo1.AddString("Stop music");
			m_wndCombo1.SetItemData(0, 0x80000000);
			for(i = 0; i < 0x45; i++)
			{
				m_wndCombo1.AddString(g_songTitles[i]);
			}

			m_wndCombo1.SetCurSel(m_currentCmd->params[0]);

			m_wndLabel1.ShowWindow(SW_SHOW);
			m_wndCombo1.ShowWindow(SW_SHOW);
			break;
		}
		default:
			m_wndLabel0.ShowWindow(SW_SHOW);
			break;
	}
}

void CEventsFormView::OnChangeEventList() 
{
	m_nCurrentEvent = m_wndEventList.GetCurSel();
	UpdateCode();
}

void CEventsFormView::OnInitialUpdate() 
{
	cdxCSizingFormView::OnInitialUpdate(m_wndMinBounds);

	AddSzControl(m_wndEventList, mdResize, mdNone);
	AddSzControl(m_wndEventPlay, mdRepos, mdNone);
	AddSzControl(m_wndSep1, mdResize, mdNone);
	AddSzControl(m_wndEventCode, mdResize, mdResize);
	AddSzControl(m_wndEventCodeAdd, mdRepos, mdRepos);
	AddSzControl(m_wndEventCodeDelete, mdRepos, mdRepos);
	AddSzControl(m_wndEventCodeClear, mdRepos, mdRepos);
	AddSzControl(m_wndEventCodeUp, mdRepos, mdRepos);
	AddSzControl(m_wndEventCodeDown, mdRepos, mdRepos);
	AddSzControl(m_wndSep2, mdResize, mdRepos);
	AddSzControl(m_wndStaticCommand, mdNone, mdRepos);
	AddSzControl(m_wndEventCommand, mdResize, mdRepos);

	AddSzControl(m_wndBitField1, mdRepos, mdRepos);
	AddSzControl(m_wndCombo1, mdRepos, mdRepos);
	AddSzControl(m_wndLabel0, mdRelative, mdRepos);
	AddSzControl(m_wndLabel1, mdResize, mdRepos);
	AddSzControl(m_wndLabel2, mdResize, mdRepos);
	AddSzControl(m_wndLabel3, mdResize, mdRepos);
	AddSzControl(m_wndLabel4, mdResize, mdRepos);
	AddSzControl(m_wndEdit1, mdRepos, mdRepos);
	AddSzControl(m_wndEditActual1, mdRepos, mdRepos);
	AddSzControl(m_wndEdit2, mdRepos, mdRepos);
	AddSzControl(m_wndEdit3, mdRepos, mdRepos);
	AddSzControl(m_wndEdit4, mdRepos, mdRepos);
	AddSzControl(m_wndEventDescription, mdResize, mdRepos);
	AddSzControl(m_wndStaticBox, mdResize, mdRepos);

	m_images.Create(IDB_EVENTIMAGES, 16, 0, RGB(255, 0, 255));
	m_wndEventCommand.SetImageList(&m_images);

	ReorganizeControls();

	m_wndEventDescription.SetBackgroundColor(FALSE, ::GetSysColor(COLOR_BTNFACE));

	CRect rect;  m_wndEventDescription.GetClientRect(&rect);
	rect.DeflateRect(2, 2);
	rect.right -= ::GetSystemMetrics(SM_CXVSCROLL);
	m_wndEventDescription.SetRect(rect);
}

int CEventsFormView::FindCommand(BYTE bCommand)
{
	COMBOBOXEXITEM cbei;
	cbei.mask = CBEIF_LPARAM;

	for(int i = 0; i < m_wndEventCommand.GetCount(); i++)
	{
		cbei.iItem = i;
		m_wndEventCommand.GetItem(&cbei);

		if(LOBYTE(cbei.lParam) == bCommand) return i;
	}
	
	return -1;
}

void CEventsFormView::OnSelChangeEventCode() 
{
	UpdateControls();
}

void CEventsFormView::strParse(LPCTSTR string, LPCTSTR delim, CStringArray* array)
{
	array->RemoveAll();

	char* temp = new char[strlen(string) + 256];
	strcpy(temp, string);

	// Now break the text up into words, and set the corresponding length array to the
	// length of each word.
	char* token = strtok(temp, delim);
	while(token != NULL)
	{
		// While there are tokens in "string"
		array->Add(token);
		// Get next token
		token = strtok(NULL, delim);
	}

	delete temp;
}

void CEventsFormView::SetRichEditText(LPCTSTR lpszText)
{
	CString string = lpszText;
	CString str;
	int fPos = 0;

	CArray<int, int> actualPos;
	CArray<CHARFORMAT, CHARFORMAT&> formats;
	CStringArray frmParams;

	CHARFORMAT2 dcf;
	dcf.cbSize = sizeof(CHARFORMAT);
	dcf.dwMask = CFM_FACE | CFM_SIZE | CFM_COLOR | CFM_BOLD | CFM_ITALIC | CFM_UNDERLINE;
	dcf.dwEffects = CFE_AUTOCOLOR;
	dcf.crTextColor = NULL;
	dcf.yHeight = 8 * 20;
	lstrcpy(dcf.szFaceName, _T("Arial"));
	actualPos.Add(0);
	formats.Add(dcf);

	// First find out how many formatting codes are present.
	for(int i = 0; i < string.GetLength(); i++)
	{
		if(string[i] == _T('|'))
		{
			actualPos.Add(fPos);
			int j = string.Mid(i + 1).Find(_T('|'));
			
			CString frmStr = string.Mid(i + 1, j);
			i += j + 1;

			CHARFORMAT2 cf;
			cf.cbSize = sizeof(CHARFORMAT);

			if(!frmStr.CompareNoCase(_T("d")))
			{
				cf.dwMask = CFM_FACE | CFM_SIZE | CFM_COLOR | CFM_BOLD | CFM_ITALIC |
					CFM_UNDERLINE;
				cf.dwEffects = CFE_AUTOCOLOR;
				cf.crTextColor = NULL;
				cf.yHeight = 8 * 20;
				lstrcpy(cf.szFaceName, _T("Arial"));
			}
			else
			{
				strParse(frmStr, _T(","), &frmParams);
				cf.dwMask = CFM_FACE;
				lstrcpy(cf.szFaceName, _T("Arial"));

				if(frmParams.GetSize() >= 1)
				{
					cf.dwMask |= CFM_SIZE;
					cf.yHeight = atoi(frmParams[0]) * 20;
				}
				if(frmParams.GetSize() >= 2)
				{
					cf.dwMask |= CFM_BOLD | CFM_ITALIC | CFM_UNDERLINE;
					cf.dwEffects = 0;
					
					if(frmParams[1].FindOneOf(_T("bB")) != -1) cf.dwEffects |= CFE_BOLD;
					if(frmParams[1].FindOneOf(_T("iI")) != -1) cf.dwEffects |= CFE_ITALIC;
					if(frmParams[1].FindOneOf(_T("uU")) != -1) cf.dwEffects |= CFE_UNDERLINE;
				}
				if(frmParams.GetSize() >= 3)
				{
					cf.dwMask |= CFM_COLOR;
					cf.crTextColor = strtoul(frmParams[2], NULL, 16);
				}
			}

			formats.Add(cf);
		}
		else
		{
			str += string[i];
			fPos++;
		}
	}

	actualPos.Add(str.GetLength());

	m_wndEventDescription.SetRedraw(FALSE);

	m_wndEventDescription.SetWindowText(str);

	for(i = 0; i < formats.GetSize(); i++)
	{
		m_wndEventDescription.SetSel(actualPos[i], actualPos[i + 1]);
		m_wndEventDescription.SetSelectionCharFormat(formats[i]);
	}

	m_wndEventDescription.SetSel(0, 0);

	m_wndEventDescription.SetRedraw(TRUE);
	m_wndEventDescription.Invalidate();
}
