#include "stdafx.h"
#include "FF4Edit.h"
#include "FF4Data.h"

DWORD DDColor(BYTE r, BYTE g, BYTE b)
{
	DWORD dwDepth = DDraw.ddpfPrimary.dwRGBBitCount;

	__asm
	{
			cmp dwDepth, 16
			jne TEST2432

			// Composition
			__asm mov al, r  __asm shl eax, 5
			__asm mov al, g  __asm shl eax, 6
			__asm mov al, b

			jmp DONE

		TEST2432:
			cmp dwDepth, 24
			jne TEST32
			jmp DO32

		TEST32:
			cmp dwDepth, 32
			jne DONE

		DO32:
			// Composition
			__asm mov al, r  __asm shl eax, 8
			__asm mov al, g  __asm shl eax, 8
			__asm mov al, b  __asm shl eax, 3

		DONE:
			//	impled return eax here;
	}
}

BYTE DDGetR(DWORD color)
{
	BYTE r;

	if(DDraw.ddpfPrimary.dwRGBBitCount == 16)
		r = (BYTE)((color >> 11) & 0x1F);
	else if(DDraw.ddpfPrimary.dwRGBBitCount == 24 || DDraw.ddpfPrimary.dwRGBBitCount == 32)
		r = (BYTE)(((color >> 16) & 0xFF) / 8);
	
	return r;
}

BYTE DDGetG(DWORD color)
{
	BYTE g;

	if(DDraw.ddpfPrimary.dwRGBBitCount == 16)
		g = (BYTE)((color >> 6) & 0x1F);
	else if(DDraw.ddpfPrimary.dwRGBBitCount == 24 || DDraw.ddpfPrimary.dwRGBBitCount == 32)
		g = (BYTE)(((color >> 8) & 0xFF) / 8);
	
	return g;
}

BYTE DDGetB(DWORD color)
{
	BYTE b;

	if(DDraw.ddpfPrimary.dwRGBBitCount == 16)
		b = (BYTE)(color & 0x1F);
	else if(DDraw.ddpfPrimary.dwRGBBitCount == 24 || DDraw.ddpfPrimary.dwRGBBitCount == 32)
		b = (BYTE)((color & 0xFF) / 8);
	
	return b;
}

DWORD Convert555ToDDColor(WORD color)
{
	return DDColor(DDGetR(color), DDGetG(color), DDGetB(color));
}

DWORD SubtractDDColor(DWORD src, DWORD dest, BYTE opacity)
{
	char dr, dg, db;
	char sr, sg, sb;

	DWORD dwDepth = DDraw.ddpfPrimary.dwRGBBitCount;

	__asm
	{
			cmp dwDepth, 16
			jne TEST2432

			// Source RGB
			__asm mov eax, src  __asm and eax, 0xF800  __asm shr eax, 11  __asm mov sr, al
			__asm mov eax, src  __asm and eax, 0x07E0  __asm shr eax, 6   __asm mov sg, al
			__asm mov eax, src  __asm and eax, 0x001F  __asm mov sb, al

			// Destination RGB
			__asm mov eax, dest  __asm and eax, 0xF800  __asm shr eax, 11  __asm mov dr, al
			__asm mov eax, dest  __asm and eax, 0x07E0  __asm shr eax, 6   __asm mov dg, al
			__asm mov eax, dest  __asm and eax, 0x001F  __asm mov db, al

			// Subtraction
			__asm mov al, sr  __asm sub al, dr  __asm div opacity  __asm add al, dr  __asm mov sr, al
			__asm mov al, sg  __asm sub al, dg  __asm div opacity  __asm add al, dg  __asm mov sg, al
			__asm mov al, sb  __asm sub al, db  __asm div opacity  __asm add al, db  __asm mov sb, al

			// Composition
			__asm mov al, sr  __asm shl eax, 5
			__asm mov al, sg  __asm shl eax, 6
			__asm mov al, sb

			jmp DONE

		TEST2432:
			cmp dwDepth, 24
			jne TEST32
			jmp DO32

		TEST32:
			cmp dwDepth, 32
			jne DONE

		DO32:
			// Source RGB
			__asm mov eax, src  __asm and eax, 0xFF0000  __asm shr eax, 19  __asm mov sr, al
			__asm mov eax, src  __asm and eax, 0x00FF00  __asm shr eax, 11  __asm mov sg, al
			__asm mov eax, src  __asm and eax, 0x0000FF  __asm shr eax, 3   __asm mov sb, al

			// Destination RGB
			__asm mov eax, dest  __asm and eax, 0xFF0000  __asm shr eax, 19  __asm mov dr, al
			__asm mov eax, dest  __asm and eax, 0x00FF00  __asm shr eax, 11  __asm mov dg, al
			__asm mov eax, dest  __asm and eax, 0x0000FF  __asm shr eax, 3   __asm mov db, al

			// Subtraction
			__asm mov al, sr  __asm sub al, dr  __asm div opacity  __asm add al, dr  __asm mov sr, al
			__asm mov al, sg  __asm sub al, dg  __asm div opacity  __asm add al, dg  __asm mov sg, al
			__asm mov al, sb  __asm sub al, db  __asm div opacity  __asm add al, db  __asm mov sb, al

			// Composition
			__asm mov al, sr  __asm shl eax, 8
			__asm mov al, sg  __asm shl eax, 8
			__asm mov al, sb  __asm shl eax, 3

		DONE:
			//	impled return eax here;
	}
}

#pragma warning(default : 4244)

DWORD SMCToLoROM(DWORD dwSMC)
{
	dwSMC -= 0x200;
	return ((dwSMC & 0x7F8000) << 1) | (dwSMC & 0x7FFF) | 0x8000;
}

DWORD LoROMToSMC(DWORD dwLoROM)
{
	return (((dwLoROM & 0xFF0000) >> 1) | (dwLoROM & 0x7FFF)) + 0x200;
}

CString FixedTextToCString(BYTE* pText, int nLength, DWORD tag, DWORD value, ... )
{
	// Fixed text doesn't use the DTE table.
	CString s;

	DWORD propTag = tag;
	DWORD propValue = value;
	CMap<DWORD, DWORD, DWORD, DWORD> tagColl;

	va_list marker;
	va_start(marker, value);
	while(propTag != TAG_END)
	{
		tagColl[propTag] = propValue;
		propTag = va_arg(marker, DWORD);
		propValue = va_arg(marker, DWORD);
	}
	va_end(marker);

	BOOL bTagFound = FALSE;
	DWORD dwValue = 0;

	for(int i = 0; i < nLength; i++)
	{
		if(pText[i] >= 0x42 && pText[i] <= 0x5B) s += pText[i] - 0x01;
		else if(pText[i] >= 0x5C && pText[i] <= 0x75) s += pText[i] + 0x05;
		else if(pText[i] >= 0x80 && pText[i] <= 0x89) s += pText[i] - 0x50;

		else if(pText[i] == 0xC0) s += "'";
		else if(pText[i] == 0xC1) s += ".";
		else if(pText[i] == 0xC2) s += "-";
		else if(pText[i] == 0xC3) s += "...";
		else if(pText[i] == 0xC4) s += "!";
		else if(pText[i] == 0xC5) s += "?";
		else if(pText[i] == 0xC6) s += "%";
		else if(pText[i] == 0xC7) s += "/";
		else if(pText[i] == 0xC8) s += ":";
		else if(pText[i] == 0xC9) s += ",";
		else if(pText[i] == 0xFF) s += " ";

		else if(pText[i] == 0x21) s += "<Stone>";
		else if(pText[i] == 0x22) s += "<Toad>";
		else if(pText[i] == 0x23) s += "<Small>";
		else if(pText[i] == 0x24) s += "<Piggy>";
		else if(pText[i] == 0x25) s += "<Mute>";
		else if(pText[i] == 0x26) s += "<Dark>";
		else if(pText[i] == 0x27) s += "<Poison>";
		else if(pText[i] == 0x28) s += "<Float>";
		else if(pText[i] == 0x29) s += "<Claw>";
		else if(pText[i] == 0x2A) s += "<Rod>";
		else if(pText[i] == 0x2B) s += "<Staff>";
		else if(pText[i] == 0x2C) s += "<Dark Sword>";
		else if(pText[i] == 0x2D) s += "<Sword>";
		else if(pText[i] == 0x2E) s += "<Large Sword>";
		else if(pText[i] == 0x2F) s += "<Spear>";
		else if(pText[i] == 0x30) s += "<Knife>";
		else if(pText[i] == 0x31) s += "<Katana>";
		else if(pText[i] == 0x32) s += "<Shuriken>";
		else if(pText[i] == 0x33) s += "<Boomerang>";
		else if(pText[i] == 0x34) s += "<Axe>";
		else if(pText[i] == 0x35) s += "<Wrench>";
		else if(pText[i] == 0x36) s += "<Harp>";
		else if(pText[i] == 0x37) s += "<Bow>";
		else if(pText[i] == 0x38) s += "<Arrow>";
		else if(pText[i] == 0x39) s += "<?>";
		else if(pText[i] == 0x3A) s += "<Whip>";
		else if(pText[i] == 0x3B) s += "<Shield>";
		else if(pText[i] == 0x3C) s += "<Helmet>";
		else if(pText[i] == 0x3D) s += "<Armor>";
		else if(pText[i] == 0x3E) s += "<Gauntlet>";
		else if(pText[i] == 0x3F) s += "<Black Magic>";
		else if(pText[i] == 0x40) s += "<White Magic>";
		else if(pText[i] == 0x41) s += "<Call Magic>";

		else s += ".";
	}

	bTagFound = tagColl.Lookup(TTCS_TrimTrailingSpaces, dwValue);
	if(bTagFound && dwValue == TRUE)
	{
		s.TrimRight();
	}

	return s;
}
