// FF4Doc.h : interface of the CFF4Doc class
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __FF4DOC_H__
#define __FF4DOC_H__

#include "FF4Data.h"

#include "MapViewDlg.h"
#include "MapTileDlg.h"
#include "MapTriggerDlg.h"
#include "GenericPropDlg.h"

#define INVOKEPROGRESS CDialog dlg(IDD_PROGRESS, AfxGetMainWnd()); \
						 dlg.Create(IDD_PROGRESS, AfxGetMainWnd())
#define ENDPROGRESS dlg.EndDialog(IDOK)

#define SETPROGRESSTITLE(s) dlg.SetWindowText(s)
#define SETPROGRESSRANGE(n) ((CProgressCtrl*)dlg.GetDlgItem(IDC_PROGRESS))->SetRange(0, n); \
							((CProgressCtrl*)dlg.GetDlgItem(IDC_PROGRESS))->SetStep(1); \
							((CProgressCtrl*)dlg.GetDlgItem(IDC_PROGRESS))->SetPos(0)
#define SETDESCRIPTION(s) dlg.SetDlgItemText(IDC_DESCRIPTION, s)
#define SETDESCRIPTION2(s) dlg.SetDlgItemText(IDC_DESCRIPTION2, s)
#define STEP ((CProgressCtrl*)dlg.GetDlgItem(IDC_PROGRESS))->StepIt()

class CFF4Doc : public CDocument
{
protected: // create from serialization only
	CFF4Doc();
	DECLARE_DYNCREATE(CFF4Doc)

	void OnProperties();

// Attributes
public:
	BOOL m_bValid;

	WorldData* worldData;
	Event* events;
	GlobalLocationData* gLocationData;

	CSize enemySize[256];
	EnemyCombination enemyCombos[512];
	Enemy enemies[256];
	BYTE enemySets[11][8];

	Item items[256];
	Character characters[17];

	BYTE dteTable[128][2];

	BYTE font[0x1000];
	WORD fontPalette[8];

	CFile* m_pFile;
	DWORD m_dwExpansionOffset;

	CTypedPtrArray<CPtrArray, LocationData*> locations;
	CTypedPtrArray<CPtrArray, LocationData*> locations2;

	BOOL ReadLocations();
	BOOL StoreLocations();

// Operations
public:
	void DestroyDialogs(CRuntimeClass* pClass);
	void CreateDialogs(CRuntimeClass* pClass, CView* pView);
	void UpdateDialogs(CRuntimeClass* pClass, CView* pView);

	CString m_szDialogClass;

	CMapViewDlg m_dlgTiles;
	CMapTileDlg m_wndTiles;
	CMapTriggerDlg m_wndTriggers;
	CGenericPropDlg m_wndGenericProp;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFF4Doc)
	public:
	virtual BOOL OnNewDocument();
	virtual void DeleteContents();
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CFF4Doc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CFF4Doc)
	afx_msg void OnFileRun();
	afx_msg void OnViewTileDialog();
	afx_msg void OnUpdateViewTileDialog(CCmdUI* pCmdUI);
	afx_msg void OnViewTileWindow();
	afx_msg void OnUpdateViewTileWindow(CCmdUI* pCmdUI);
	afx_msg void OnViewTriggerWindow();
	afx_msg void OnUpdateViewTriggerWindow(CCmdUI* pCmdUI);
	afx_msg void OnViewGenericPropWindow();
	afx_msg void OnUpdateViewGenericPropWindow(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

#endif
