// FF4Edit.h : main header file for the FF4EDIT application
//

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

#ifndef __FF4EDIT_H__
#define __FF4EDIT_H__

/////////////////////////////////////////////////////////////////////////////
// CFF4EditApp:
// See FF4Edit.cpp for the implementation of this class
//

#define WM_UPDATEFLEXPANE	(WM_APP + 0x100)

class DDrawUtil
{
public:
	// Functions
	LPDIRECTDRAWPALETTE LoadPalette(LPDIRECTDRAW4 pdd, LPCSTR szBitmap);
	LPDIRECTDRAWSURFACE4 LoadBitmap(LPDIRECTDRAW4 pdd, LPCSTR szBitmap, int dx, int dy);
	LPDIRECTDRAWSURFACE4 LoadSizeBitmap(LPDIRECTDRAW4 pdd, LPCSTR szBitmap, int *dx, int *dy);
	HRESULT ReLoadBitmap(LPDIRECTDRAWSURFACE4 pdds, LPCSTR szBitmap);
	HRESULT CopyBitmap(LPDIRECTDRAWSURFACE4 pdds, HBITMAP hbm, int x, int y, int dx, int dy);
	DWORD ColorMatch(LPDIRECTDRAWSURFACE4 pdds, COLORREF rgb);
	HRESULT SetColorKey(LPDIRECTDRAWSURFACE4 pdds, COLORREF rgb);
	void Error(HRESULT hErr, HWND hWnd);

	// Variables
	LPDIRECTDRAW4 lpDD;
	LPDIRECTDRAWSURFACE4 lpSurfFront;
	DDPIXELFORMAT ddpfPrimary;
	LPDIRECTDRAWCLIPPER lpClipper;
	DWORD dwColorBG, dwColorBlack, dwColorGrid, dwColorCursor;
};

class Classes
{
public:
	CString InfoTipClass;
};

typedef struct __WINDOWSPECS
{
	RECT rect;
	BOOL bVisible, bMaximized, bMinimized;
} WINDOWSPECS;

class AppSettings
{
public:
	AppSettings();
	~AppSettings();

	CString FormatWindowSpecs(WINDOWSPECS* ws);
	BOOL ExtractWindowSpecs(CString& str, WINDOWSPECS* ws);

	BOOL bMapGridlines, bAdvanced;

	WINDOWSPECS wsMainWindow;
	WINDOWSPECS wsTileDlg, wsTileWnd, wsTriggerWnd;
	WINDOWSPECS wsGenericPropWnd;
};

class CFF4EditApp : public CWinApp
{
public:
	void OnProperties();
	DDrawUtil _DDraw;
	Classes _Classes;
	AppSettings* _Settings;

	UINT clipboardWorldMap;

	CFF4EditApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFF4EditApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CFF4EditApp)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

#define App (*(CFF4EditApp*)AfxGetApp())
#define DDraw (((CFF4EditApp*)AfxGetApp())->_DDraw)
#define Classes (((CFF4EditApp*)AfxGetApp())->_Classes)
#define Settings (*(((CFF4EditApp*)AfxGetApp())->_Settings))

#endif
