// GenericPropDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FF4Edit.h"
#include "GenericPropDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGenericPropDlg dialog


CGenericPropDlg::CGenericPropDlg(CWnd* pParent /*=NULL*/)
	: cdxCSizingDialog(CGenericPropDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGenericPropDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CGenericPropDlg::DoDataExchange(CDataExchange* pDX)
{
	cdxCSizingDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGenericPropDlg)
	DDX_Control(pDX, IDC_PROPTREE, m_wndPropTree);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGenericPropDlg, cdxCSizingDialog)
	//{{AFX_MSG_MAP(CGenericPropDlg)
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	ON_NOTIFY(PROPTN_PROPCHANGED, IDC_PROPTREE, OnChangeProperties)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGenericPropDlg message handlers

BOOL CGenericPropDlg::OnInitDialog() 
{
	cdxCSizingDialog::OnInitDialog();
	
	AddSzControl(m_wndPropTree, mdResize, mdResize);

	SetWindowPos(NULL, Settings.wsGenericPropWnd.rect.left, Settings.wsGenericPropWnd.rect.top,
		Settings.wsGenericPropWnd.rect.right - Settings.wsGenericPropWnd.rect.left,
		Settings.wsGenericPropWnd.rect.bottom - Settings.wsGenericPropWnd.rect.top,
		(Settings.wsGenericPropWnd.bVisible ? SWP_SHOWWINDOW : SWP_HIDEWINDOW) | SWP_NOZORDER);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CGenericPropDlg::OnClose() 
{
	ShowWindow(SW_HIDE);
}

void CGenericPropDlg::OnDestroy() 
{
	GetWindowRect(&Settings.wsGenericPropWnd.rect);

	cdxCSizingDialog::OnDestroy();
}

BOOL CGenericPropDlg::Create(CView* pView) 
{
	m_pView = pView;
	return cdxCSizingDialog::Create(IDD, NULL);
}

void CGenericPropDlg::OnChangeProperties(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NMPROPTREE* pNMPropTree = (NMPROPTREE*)pNMHDR;

	switch(pNMPropTree->node->id)
	{
		case 0:
			m_locationData->battleBackground &= ~LD_BATTLEBACKGROUND;
			m_locationData->battleBackground |= (pNMPropTree->node->lData2);
			break;

		case 1:
			m_locationData->battleBackground &= ~LD_BATTLEALTPALETTE;
			if(pNMPropTree->node->lData) m_locationData->battleBackground |= LD_BATTLEALTPALETTE;
			break;

		case 2:
			m_locationData->battleBackground &= ~LD_BATTLEMAGNETIC;
			if(pNMPropTree->node->lData) m_locationData->battleBackground |= LD_BATTLEMAGNETIC;
			break;

		case 10:		// Map Index
			m_locationData->mapIndex = pNMPropTree->node->lData;
			m_pView->Invalidate();
			break;

		case 20:		// Tile set
			m_locationData->tileSet = pNMPropTree->node->lData;
			m_pView->Invalidate();
			break;

		case 30:		// NPC Index
			m_locationData->NPCIndex = pNMPropTree->node->lData;
			break;

		case 40:		// Surrounding tile
			m_locationData->borderTile = pNMPropTree->node->lData;
			m_pView->Invalidate();
			break;

		case 50:		// Palette Index
			m_locationData->paletteIndex = pNMPropTree->node->lData;
			m_pView->Invalidate();
			break;

		case 60:		// NPC Palette Index
			m_locationData->NPCPaletteIndex = pNMPropTree->node->lData;
			break;

		case 70:		// Music index
			m_locationData->musicIndex = pNMPropTree->node->lData;
			break;

		case 80:
			m_locationData->backgroundTile = pNMPropTree->node->lData;
			m_pView->Invalidate();
			break;

		case 90:
			m_locationData->scrollSpecs &= ~SSF_DIRECTION;
			m_locationData->scrollSpecs |= (pNMPropTree->node->lData2 << 4);
			break;

		case 91:
			m_locationData->scrollSpecs &= ~SSF_SPEED;
			m_locationData->scrollSpecs |= (pNMPropTree->node->lData << 6);
			break;

		case 92:
			m_locationData->scrollSpecs &= ~SSF_VERTSTICKY;
			if(pNMPropTree->node->lData) m_locationData->scrollSpecs |= SSF_VERTSTICKY;
			break;

		case 93:
			m_locationData->scrollSpecs &= ~SSF_HORZSTICKY;
			if(pNMPropTree->node->lData) m_locationData->scrollSpecs |= SSF_HORZSTICKY;
			break;

		case 94:
			m_locationData->scrollSpecs &= ~SSF_TRANSPARENT;
			if(pNMPropTree->node->lData) m_locationData->scrollSpecs |= SSF_TRANSPARENT;
			break;

		case 100:
			m_locationData->UK2 = pNMPropTree->node->lData;
			break;

		case 110:
			m_locationData->titleIndex = pNMPropTree->node->lData;
			break;

		case 120:
			m_locationData->UK3 = pNMPropTree->node->lData;
			break;
	}

/*	if(pNMPropTree->node->id != WDF_BATTLEBACKGROUND)
	{
		m_worldData->tileProperties[sel] = (m_worldData->tileProperties[sel] & ~pNMPropTree->node->id) |
			((pNMPropTree->node->lData) ? pNMPropTree->node->id : 0);
	}
	else
	{
		m_worldData->tileProperties[sel] = (m_worldData->tileProperties[sel] & ~pNMPropTree->node->id) |
			(pNMPropTree->node->lData2 << 8);
	}
*/
	*pResult = 0;
}
