// MapTriggerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FF4Edit.h"
#include "MapTriggerDlg.h"
#include "MapView.h"

#include "EditTriggerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMapTriggerDlg dialog


CMapTriggerDlg::CMapTriggerDlg(CWnd* pParent /*=NULL*/)
	: cdxCSizingDialog(CMapTriggerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMapTriggerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CMapTriggerDlg::DoDataExchange(CDataExchange* pDX)
{
	cdxCSizingDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMapTriggerDlg)
	DDX_Control(pDX, IDC_DELETEALLTRIGGERS, m_wndDeleteAllTriggers);
	DDX_Control(pDX, IDC_DELETETRIGGER, m_wndDeleteTrigger);
	DDX_Control(pDX, IDC_EDITTRIGGER, m_wndEditTrigger);
	DDX_Control(pDX, IDC_ADDTRIGGER, m_wndAddTrigger);
	DDX_Control(pDX, IDC_GOTODESTINATION, m_wndGotoDestination);
	DDX_Control(pDX, IDC_GOTOTRIGGER, m_wndGotoTrigger);
	DDX_Control(pDX, IDC_TRIGGERLIST, m_wndTriggerList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMapTriggerDlg, cdxCSizingDialog)
	//{{AFX_MSG_MAP(CMapTriggerDlg)
	ON_BN_CLICKED(IDC_GOTOTRIGGER, OnGotoTrigger)
	ON_LBN_SELCHANGE(IDC_TRIGGERLIST, OnSelchangeTriggerList)
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	ON_LBN_DBLCLK(IDC_TRIGGERLIST, OnEditTrigger)
	ON_BN_CLICKED(IDC_EDITTRIGGER, OnEditTrigger)
	ON_BN_CLICKED(IDC_ADDTRIGGER, OnAddTrigger)
	ON_BN_CLICKED(IDC_DELETETRIGGER, OnDeleteTrigger)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapTriggerDlg message handlers

BOOL CMapTriggerDlg::OnInitDialog() 
{
	cdxCSizingDialog::OnInitDialog();
	
	AddSzControl(m_wndTriggerList, mdResize, mdResize);
	AddSzControl(m_wndGotoTrigger, mdNone, mdRepos);
	AddSzControl(m_wndGotoDestination, mdNone, mdRepos);
	AddSzControl(m_wndAddTrigger, mdNone, mdRepos);
	AddSzControl(m_wndEditTrigger, mdNone, mdRepos);
	AddSzControl(m_wndDeleteTrigger, mdNone, mdRepos);
	AddSzControl(m_wndDeleteAllTriggers, mdNone, mdRepos);
	
	SetWindowPos(NULL, Settings.wsTriggerWnd.rect.left, Settings.wsTriggerWnd.rect.top,
		Settings.wsTriggerWnd.rect.right - Settings.wsTriggerWnd.rect.left,
		Settings.wsTriggerWnd.rect.bottom - Settings.wsTriggerWnd.rect.top,
		(Settings.wsTriggerWnd.bVisible ? SWP_SHOWWINDOW : SWP_HIDEWINDOW) | SWP_NOZORDER);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMapTriggerDlg::OnClose() 
{
	ShowWindow(SW_HIDE);
}

void CMapTriggerDlg::OnGotoTrigger() 
{
	int sel = m_wndTriggerList.GetCurSel();
	Entrance* pEntr = (Entrance*)m_wndTriggerList.GetItemData(sel);

	CRect rect;  m_pView->GetClientRect(rect);
	int nWidth = rect.Width() / 16;
	int nHeight = rect.Height() / 16;

	((CMapView*)m_pView)->ScrollToPosition(CPoint((pEntr->srcX - nWidth / 2),
		(pEntr->srcY - nHeight / 2)));
}

void CMapTriggerDlg::OnSelchangeTriggerList() 
{
	int sel = m_wndTriggerList.GetCurSel();
	Entrance* pEntr = (Entrance*)m_wndTriggerList.GetItemData(sel);

	if(pEntr->destination == 0xFF)
		m_wndGotoDestination.EnableWindow(FALSE);
	else
		m_wndGotoDestination.EnableWindow(TRUE);

	((CMapView*)m_pView)->SetCurrentTrigger(CPoint(pEntr->srcX, pEntr->srcY));
}

BOOL CMapTriggerDlg::Create(CView* pView) 
{
	m_pView = pView;
	return CDialog::Create(IDD, NULL);
}

void CMapTriggerDlg::OnDestroy() 
{
	GetWindowRect(&Settings.wsTriggerWnd.rect);
	Settings.wsTriggerWnd.bVisible = (IsWindowVisible()) ? TRUE : FALSE;

	cdxCSizingDialog::OnDestroy();
}

void CMapTriggerDlg::OnEditTrigger() 
{
	int sel = m_wndTriggerList.GetCurSel();
	Entrance* pEntr = (Entrance*)m_wndTriggerList.GetItemData(sel);

	CEditTriggerDlg dlg;

	dlg.m_nSourceX = pEntr->srcX;
	dlg.m_nSourceY = pEntr->srcY;

	if(pEntr->destination == 0xFF)
	{
		dlg.m_nDestType = 1;
		dlg.m_nDestEvent = pEntr->destX;
	}
	else
	{
		dlg.m_nDestType = 0;
		dlg.m_nDestination = pEntr->destination;
		dlg.m_nDestX = pEntr->destX;
		dlg.m_nDestY = pEntr->destY;
	}

	if(dlg.DoModal() == IDOK)
	{
		pEntr->srcX = dlg.m_nSourceX;
		pEntr->srcY = dlg.m_nSourceY;

		if(dlg.m_nDestType == 1)
		{
			pEntr->destination = 0xFF;
			pEntr->destX = dlg.m_nDestEvent;
			pEntr->destY = 0;
		}
		else
		{
			pEntr->destination = dlg.m_nDestination;
			pEntr->destX = dlg.m_nDestX;
			pEntr->destY = dlg.m_nDestY;
		}
	}

	CRect rect;  m_wndTriggerList.GetItemRect(sel, &rect);
	m_wndTriggerList.InvalidateRect(&rect);

	m_pView->Invalidate();
	((CMapView*)m_pView)->SetCurrentTrigger(CPoint(pEntr->srcX, pEntr->srcY));
}

void CMapTriggerDlg::OnAddTrigger() 
{
	if(m_worldData->entrances.GetSize() == 256)
	{
		AfxMessageBox("You have reached the maximum number\nof allowed triggers (256).",
			MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	Entrance* pEntr = new Entrance;

	CEditTriggerDlg dlg;

	dlg.m_nSourceX = 0;
	dlg.m_nSourceY = 0;
	dlg.m_nDestType = 0;
	dlg.m_nDestination = 0;
	dlg.m_nDestX = 0;
	dlg.m_nDestY = 0;
	dlg.m_nDestEvent = 0;

	if(dlg.DoModal() == IDOK)
	{
		pEntr->srcX = dlg.m_nSourceX;
		pEntr->srcY = dlg.m_nSourceY;

		if(dlg.m_nDestType == 1)
		{
			pEntr->destination = 0xFF;
			pEntr->destX = dlg.m_nDestEvent;
			pEntr->destY = 0;
		}
		else
		{
			pEntr->destination = dlg.m_nDestination;
			pEntr->destX = dlg.m_nDestX;
			pEntr->destY = dlg.m_nDestY;
		}

		int nIndex = m_wndTriggerList.AddString(NULL);
		m_wndTriggerList.SetItemData(nIndex, (DWORD)pEntr);

		m_worldData->entrances.Add(pEntr);
		m_pView->Invalidate();
		((CMapView*)m_pView)->SetCurrentTrigger(CPoint(pEntr->srcX, pEntr->srcY));
	}
	else
	{
		delete pEntr;
	}
}

void CMapTriggerDlg::OnDeleteTrigger() 
{
	int sel = m_wndTriggerList.GetCurSel();
	if(sel == -1) return;

	int res = AfxMessageBox("This operation is permanent and\ncannot be undone.  Continue?",
		MB_OKCANCEL | MB_ICONEXCLAMATION);

	if(res == IDCANCEL) return;

	Entrance* pEntr = (Entrance*)m_wndTriggerList.GetItemData(sel);

	for(int i = 0; i < m_worldData->entrances.GetSize(); i++)
	{
		if(pEntr == m_worldData->entrances[i])
		{
			m_wndTriggerList.DeleteString(i);
			m_worldData->entrances.RemoveAt(i);
			delete pEntr;

			m_pView->Invalidate();
			return;
		}
	}

	AfxMessageBox("The trigger wasn't found--this is bad.\nLet me know if you see this.");
}
