// MapViewDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FF4Edit.h"
#include "MapViewDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMapViewDlg dialog


CMapViewDlg::CMapViewDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMapViewDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMapViewDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CMapViewDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMapViewDlg)
	DDX_Control(pDX, IDC_PAL_BLUEEDIT, m_wndBlueEdit);
	DDX_Control(pDX, IDC_PAL_GREENEDIT, m_wndGreenEdit);
	DDX_Control(pDX, IDC_PAL_REDEDIT, m_wndRedEdit);
	DDX_Control(pDX, IDC_PAL_BLUESLIDER, m_wndBlueSlider);
	DDX_Control(pDX, IDC_PAL_GREENSLIDER, m_wndGreenSlider);
	DDX_Control(pDX, IDC_PAL_REDSLIDER, m_wndRedSlider);
	DDX_Control(pDX, IDC_TFP_PROPTREE, m_wndPropTree);
	DDX_Control(pDX, IDC_PAL_PALETTES, m_wndPalettes);
	DDX_Control(pDX, IDC_PAL_COLORS, m_wndColors);
	DDX_Control(pDX, IDC_TFP_TILEEDIT, m_wndTileEdit);
	DDX_Control(pDX, IDC_TFP_CURRENTTILE, m_wndCurrentTile);
	DDX_Control(pDX, IDC_TFP_SMALLTILELIST, m_wndSmallTileList);
	DDX_Control(pDX, IDC_TFP_TILELIST, m_wndTileList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMapViewDlg, CDialog)
	//{{AFX_MSG_MAP(CMapViewDlg)
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	ON_WM_HSCROLL()
	ON_LBN_SELCHANGE(IDC_TFP_TILELIST, OnSelchangeTileList)
	ON_LBN_SELCHANGE(IDC_TFP_SMALLTILELIST, OnSelchangeSmallTileList)
	ON_CBN_SELENDOK(IDC_PAL_PALETTES, OnSelendokPalPalettes)
	ON_LBN_SELCHANGE(IDC_PAL_COLORS, OnSelchangePalColors)
	ON_CONTROL(TFW_TILEPARTCHANGE, IDC_TFP_CURRENTTILE, OnPartChangeCurrentTile)
	ON_CONTROL(TEW_TILEEDIT, IDC_TFP_TILEEDIT, OnEditCurrentTile)
	ON_NOTIFY(PROPTN_PROPCHANGED, IDC_TFP_PROPTREE, OnChangeProperties)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapViewDlg message handlers

BOOL CMapViewDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	SetWindowPos(NULL, Settings.wsTileDlg.rect.left, Settings.wsTileDlg.rect.top, 0, 0,
		(Settings.wsTileDlg.bVisible ? SWP_SHOWWINDOW : SWP_HIDEWINDOW) | SWP_NOSIZE | SWP_NOZORDER);

	((CSliderCtrl*)GetDlgItem(IDC_PAL_REDSLIDER))->SetRange(0, 31);
	((CSliderCtrl*)GetDlgItem(IDC_PAL_GREENSLIDER))->SetRange(0, 31);
	((CSliderCtrl*)GetDlgItem(IDC_PAL_BLUESLIDER))->SetRange(0, 31);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMapViewDlg::OnClose() 
{
	ShowWindow(SW_HIDE);
}

void CMapViewDlg::OnDestroy() 
{
	GetWindowRect(&Settings.wsTileDlg.rect);
	Settings.wsTileDlg.bVisible = (IsWindowVisible()) ? TRUE : FALSE;

	CDialog::OnDestroy();
}

BOOL CMapViewDlg::Create(CView* pView) 
{
	m_pView = pView;
	return CDialog::Create(IDD, NULL);
}

void CMapViewDlg::OnSelchangeTileList() 
{
	int sel = m_wndTileList.GetCurSel();
	m_wndCurrentTile.SetCurrentTile(sel);

	UpdateTileProperties(sel);
}

void CMapViewDlg::OnSelchangeSmallTileList() 
{
	int sel = m_wndSmallTileList.GetCurSel();

	m_worldData->tileFormations[m_wndCurrentTile.m_bCurrentTile + m_wndCurrentTile.m_bCurrentTilePart * 128] = sel;

	m_wndCurrentTile.Invalidate();

	UpdatePalette(m_worldData->tilePalettes[sel] / 16);
	UpdateTileEdit(sel);

	CRect itemRect;  m_wndTileList.GetItemRect(m_wndCurrentTile.m_bCurrentTile, &itemRect);
	m_wndTileList.InvalidateRect(&itemRect);

	m_pView->Invalidate();
}

void CMapViewDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	int nPalette = ((CComboBox*)GetDlgItem(IDC_PAL_PALETTES))->GetCurSel();
	int nColor = ((CListBox*)GetDlgItem(IDC_PAL_COLORS))->GetCurSel();

	BYTE r = ((CSliderCtrl*)GetDlgItem(IDC_PAL_REDSLIDER))->GetPos();
	BYTE g = ((CSliderCtrl*)GetDlgItem(IDC_PAL_GREENSLIDER))->GetPos();
	BYTE b = ((CSliderCtrl*)GetDlgItem(IDC_PAL_BLUESLIDER))->GetPos();

	SetDlgItemInt(IDC_PAL_REDEDIT, r, FALSE);
	SetDlgItemInt(IDC_PAL_GREENEDIT, g, FALSE);
	SetDlgItemInt(IDC_PAL_BLUEEDIT, b, FALSE);

	m_worldData->palette[nPalette * 16 + nColor] = RGB555(b, g, r);

	CRect rect;
	((CListBox*)GetDlgItem(IDC_PAL_COLORS))->GetItemRect(nColor, &rect);
	GetDlgItem(IDC_PAL_COLORS)->InvalidateRect(&rect);
	
	m_wndTileList.Invalidate();
	m_wndSmallTileList.Invalidate();
	m_wndCurrentTile.Invalidate();
	m_wndTileEdit.Invalidate();
	m_pView->Invalidate();
		
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CMapViewDlg::OnPartChangeCurrentTile()
{
	int sel = m_worldData->tileFormations[m_wndCurrentTile.m_bCurrentTile + 128 * m_wndCurrentTile.m_bCurrentTilePart];
	UpdateSmallTileList(sel);
}

void CMapViewDlg::OnEditCurrentTile()
{
	m_wndTileList.Invalidate();
	m_wndSmallTileList.Invalidate();
	m_wndCurrentTile.Invalidate();
	m_pView->Invalidate();
}

void CMapViewDlg::OnSelendokPalPalettes() 
{
	int sel = m_wndPalettes.GetCurSel();

	m_worldData->tilePalettes[m_wndSmallTileList.GetCurSel()] = sel * 16;

	m_wndTileList.Invalidate();
	m_wndSmallTileList.Invalidate();
	m_wndCurrentTile.Invalidate();
	m_pView->Invalidate();

	UpdateColors(sel);
}

void CMapViewDlg::OnSelchangePalColors() 
{
	m_wndTileEdit.SetEditColor(m_wndColors.GetCurSel());
	UpdateColorSliders(m_wndColors.GetCurSel());
}

void CMapViewDlg::OnChangeProperties(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int sel = m_wndTileList.GetCurSel();

	NMPROPTREE* pNMPropTree = (NMPROPTREE*)pNMHDR;

	if(pNMPropTree->node->id != WDF_BATTLEBACKGROUND)
	{
		m_worldData->tileProperties[sel] = (m_worldData->tileProperties[sel] & ~pNMPropTree->node->id) |
			((pNMPropTree->node->lData) ? pNMPropTree->node->id : 0);
	}
	else
	{
		m_worldData->tileProperties[sel] = (m_worldData->tileProperties[sel] & ~pNMPropTree->node->id) |
			(pNMPropTree->node->lData2 << 8);
	}

	*pResult = 0;
}

void CMapViewDlg::UpdateSmallTileList(int sel)
{
	m_wndSmallTileList.SetCurSel(sel);
	UpdatePalette(m_worldData->tilePalettes[sel] / 16);
	UpdateTileEdit(sel);
}

void CMapViewDlg::UpdateTileEdit(int sel)
{
	m_wndTileEdit.SetCurrentTile(sel);
}

void CMapViewDlg::UpdatePalette(int sel)
{
	m_wndPalettes.SetCurSel(sel);
	UpdateColors(sel);
}

void CMapViewDlg::UpdateColors(int sel)
{
	m_wndColors.ResetContent();

	CRect clientRect;
	m_wndColors.GetClientRect(&clientRect);

	m_wndColors.SetItemHeight(0, clientRect.Height());
	m_wndColors.SetColumnWidth(clientRect.Width() / 16);
	for(int i = 0; i < 16; i++)
	{
		int nIndex = m_wndColors.AddString("COLOR");
	}

	m_wndColors.SetCurSel(0);

	UpdateColorSliders(0);
}

void CMapViewDlg::UpdateColorSliders(int sel)
{
	WORD wEntry = m_worldData->palette[m_wndPalettes.GetCurSel() * 16 + sel];
	BYTE b = R555(wEntry);
	BYTE g = G555(wEntry);
	BYTE r = B555(wEntry);

	SetDlgItemInt(IDC_PAL_REDEDIT, r, FALSE);
	SetDlgItemInt(IDC_PAL_GREENEDIT, g, FALSE);
	SetDlgItemInt(IDC_PAL_BLUEEDIT, b, FALSE);

	m_wndRedSlider.SetPos(r);
	m_wndGreenSlider.SetPos(g);
	m_wndBlueSlider.SetPos(b);
}

void CMapViewDlg::UpdateTileProperties(int sel)
{
	WORD wProp = m_worldData->tileProperties[sel];

	m_wndPropTree.SetItem(WDF_CHARAWALK, ((wProp & WDF_CHARAWALK) ? TRUE : FALSE));
	m_wndPropTree.SetItem(WDF_CHOCOWALK, ((wProp & WDF_CHOCOWALK) ? TRUE : FALSE));
	m_wndPropTree.SetItem(WDF_BLACKCHOCOFLY, ((wProp & WDF_BLACKCHOCOFLY) ? TRUE : FALSE));
	m_wndPropTree.SetItem(WDF_BLACKCHOCOLAND, ((wProp & WDF_BLACKCHOCOLAND) ? TRUE : FALSE));
	m_wndPropTree.SetItem(WDF_HOVERCRAFTMOVE, ((wProp & WDF_HOVERCRAFTMOVE) ? TRUE : FALSE));
	m_wndPropTree.SetItem(WDF_AIRSHIPFLY, ((wProp & WDF_AIRSHIPFLY) ? TRUE : FALSE));
	m_wndPropTree.SetItem(WDF_CHARAWALK2, ((wProp & WDF_CHARAWALK2) ? TRUE : FALSE));
	m_wndPropTree.SetItem(WDF_BIGWHALEFLY, ((wProp & WDF_BIGWHALEFLY) ? TRUE : FALSE));
	m_wndPropTree.SetItem(WDF_SHOWCHARATOPHALF, ((wProp & WDF_SHOWCHARATOPHALF) ? TRUE : FALSE));
	m_wndPropTree.SetItem(WDF_AIRSHIPLAND, ((wProp & WDF_AIRSHIPLAND) ? TRUE : FALSE));
	m_wndPropTree.SetItem(WDF_UNKNOWN2, ((wProp & WDF_UNKNOWN2) ? TRUE : FALSE));
	m_wndPropTree.SetItem(WDF_ENEMYENCOUNTERS, ((wProp & WDF_ENEMYENCOUNTERS) ? TRUE : FALSE));
	m_wndPropTree.SetItem(WDF_ENTRANCE, ((wProp & WDF_ENTRANCE) ? TRUE : FALSE));
	m_wndPropTree.SetItem(WDF_BATTLEBACKGROUND, PROP_DONOTCHANGE, HIBYTE(wProp & WDF_BATTLEBACKGROUND));
}
