#if !defined(AFX_MAPVIEWDLG_H__F6368644_41B9_11D3_BC29_DCC32656C339__INCLUDED_)
#define AFX_MAPVIEWDLG_H__F6368644_41B9_11D3_BC29_DCC32656C339__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MapViewDlg.h : header file
//

#include "PaletteList.h"
#include "TileListBox.h"
#include "SmallTileListBox.h"
#include "TileFormationWnd.h"
#include "TileEditWnd.h"
#include "PropertyTree.h"

/////////////////////////////////////////////////////////////////////////////
// CMapViewDlg dialog

class CMapViewDlg : public CDialog
{
// Construction
public:
	CMapViewDlg(CWnd* pParent = NULL);   // standard constructor
	CView* m_pView;

	WorldData* m_worldData;

// Dialog Data
	//{{AFX_DATA(CMapViewDlg)
	enum { IDD = IDD_MAPVIEW };
	CEdit	m_wndBlueEdit;
	CEdit	m_wndGreenEdit;
	CEdit	m_wndRedEdit;
	CSliderCtrl	m_wndBlueSlider;
	CSliderCtrl	m_wndGreenSlider;
	CSliderCtrl	m_wndRedSlider;
	CPropertyTree	m_wndPropTree;
	CComboBox	m_wndPalettes;
	CPaletteList	m_wndColors;
	CTileEditWnd	m_wndTileEdit;
	CTileFormationWnd	m_wndCurrentTile;
	CSmallTileListBox	m_wndSmallTileList;
	CTileListBox	m_wndTileList;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMapViewDlg)
	public:
	virtual BOOL Create(CView* pView);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void UpdateTileProperties(int sel);
	void UpdatePalette(int sel);
	void UpdateColors(int sel);
	void UpdateColorSliders(int sel);
	void UpdateSmallTileList(int sel);
	void UpdateTileEdit(int sel);

	// Generated message map functions
	//{{AFX_MSG(CMapViewDlg)
	afx_msg void OnClose();
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSelchangeTileList();
	afx_msg void OnSelchangeSmallTileList();
	afx_msg void OnSelendokPalPalettes();
	afx_msg void OnSelchangePalColors();
	afx_msg void OnPartChangeCurrentTile();
	afx_msg void OnEditCurrentTile();
	afx_msg void OnChangeProperties(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAPVIEWDLG_H__F6368644_41B9_11D3_BC29_DCC32656C339__INCLUDED_)
