// PropTreeInLineEdit.cpp : implementation file
//

#include "stdafx.h"
#include "PropTreeInLineEdit.h"

#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPropTreeInLineEdit

CPropTreeInLineEdit::CPropTreeInLineEdit()
{
	m_dwFlags = 0;
}

CPropTreeInLineEdit::~CPropTreeInLineEdit()
{
	DestroyWindow();
}


BEGIN_MESSAGE_MAP(CPropTreeInLineEdit, CEdit)
	//{{AFX_MSG_MAP(CPropTreeInLineEdit)
	ON_CONTROL_REFLECT(EN_KILLFOCUS, OnKillFocus)
	ON_WM_CHAR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPropTreeInLineEdit message handlers

BOOL CPropTreeInLineEdit::Create(DWORD dwStyle, CWnd* pParentWnd, UINT nID) 
{
	WNDCLASS wc;
	::GetClassInfo(NULL, _T("Edit"), &wc);
	wc.style |= CS_SAVEBITS;
	wc.lpszClassName = _T("PropTreeInLineEdit");
	AfxRegisterClass(&wc);

	dwStyle |= WS_CHILD | WS_CLIPSIBLINGS | ES_LEFT | ES_AUTOHSCROLL;

	BOOL rval = CreateEx(WS_EX_TOOLWINDOW, _T("PropTreeInLineEdit"), NULL, dwStyle,
		0, 0, 0, 0, pParentWnd->GetSafeHwnd(), NULL);
	
	return rval;
}

void CPropTreeInLineEdit::DoModal()
{
	ShowWindow(SW_SHOW);
	SetFocus();
	m_nModalResult = RunModalLoop(NULL);
}

void CPropTreeInLineEdit::OnKillFocus() 
{
	GetWindowText(m_strText);
	EndModalLoop(m_nModalResult);
	DestroyWindow();
}

void CPropTreeInLineEdit::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if(nChar == VK_ESCAPE)
	{
		m_strText.Empty();
		EndModalLoop(m_nModalResult);
		DestroyWindow();
		return;
	}
	if(nChar == VK_RETURN || nChar == VK_TAB)
	{
		GetWindowText(m_strText);
		EndModalLoop(m_nModalResult);
		DestroyWindow();
		return;
	}
	
	CEdit::OnChar(nChar, nRepCnt, nFlags);

	// If the control should grow, do it.
	if(m_dwFlags & PTEF_GROWHORIZ)
	{
		CString str;

		GetWindowText(str);
		CWindowDC dc(this);
		CFont *pFont = GetFont();
		CFont *pFontDC = dc.SelectObject(pFont);
		CSize size = dc.GetTextExtent(str);
		dc.SelectObject(pFontDC);
		size.cx += 12;

		CRect rect; GetWindowRect(&rect);

		if(size.cx > rect.Width())
		{
			rect.right = rect.left + size.cx;
			MoveWindow(&rect);
			RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_UPDATENOW | RDW_FRAME);
		}
	}
}

BOOL CPropTreeInLineEdit::PreTranslateMessage(MSG* pMsg) 
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_DELETE || pMsg->wParam == VK_ESCAPE || 
			pMsg->wParam == VK_RIGHT || pMsg->wParam == VK_LEFT || pMsg->wParam == VK_UP || pMsg->wParam == VK_DOWN || 
			pMsg->wParam == VK_TAB || GetKeyState(VK_CONTROL))
		{
			::TranslateMessage(pMsg);
			::DispatchMessage(pMsg);
			return TRUE;
		}
	}
	
	return CEdit::PreTranslateMessage(pMsg);
}

void CPropTreeInLineEdit::SetFlags(DWORD flags)
{

}
